package Element;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Line2D;

public class Element {
	private Line2D lineElement;

	private String name;

	private Ellipse2D.Double ellipse;

	private int score = 10;

	public Element(String name) {
		this.name = name;
		lineElement = new Line2D.Double();
		this.ellipse = new Ellipse2D.Double(0, 0, 0, 0);
	}

	public void setPositon(Point start, Point end) {
		this.lineElement.setLine(start.x, start.y, end.x, end.y);
		this.ellipse.x = end.x - 3;
		this.ellipse.y = end.y - 3;
		this.ellipse.width = 6;
		this.ellipse.height = 6;
	}

	public boolean intersects(Point p) {
		Rectangle r = new Rectangle(p.x - 2, p.y - 2, 4, 4);
		if (this.lineElement.intersects(r)) {
			return true;
		} else {
			return false;
		}
	}

	public void setEllipsePosition(Point p) {
		this.ellipse.x = p.x - 3;
		this.ellipse.y = p.y - 3;
	}

	public Point getEllipsePoint() {
		Point p = new Point((int) this.ellipse.getX() + 3, (int) this.ellipse
				.getY() + 3);
		return p;
	}

	public String getName() {
		return this.name;
	}

	public int getScore(Point p) {
		Rectangle r = this.lineElement.getBounds();
		double length = Math.sqrt(r.width * r.width + r.height * r.height);// 
																			// 밢
		double distance = Math.sqrt(Math.abs(p.x - this.lineElement.getX2())
				* Math.abs(p.x - this.lineElement.getX2())
				+ // Ʈκ γ 밢
				Math.abs(p.y - this.lineElement.getY2())
				* Math.abs(p.y - this.lineElement.getY2()));
		double result = (length - distance) / length;
		this.score = (int) (result * 10);
		// System.out.println("length :"+length);
		// System.out.println("distance :"+distance);
		// System.out.println("result :"+result);
		if (this.score == 10) {
			return 9;
		} else {
			return this.score;
		}
	}

	public void paint(Graphics2D g) {
		g.setColor(Color.white);
		g.draw(this.lineElement);
		g.fill(this.ellipse);
	}
}
