package UI_Frames;

import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.net.InetAddress;
import java.net.UnknownHostException;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import com.nilo.plaf.nimrod.NimRODLookAndFeel;
import com.nilo.plaf.nimrod.NimRODTheme;
import Communication.SocketThread;
import Element.Product;
import Element.UserInfo;
import Element.UserInformation;
import Handlers.MainFrameListener;
import UI_Panels.PanelHistory;
import UI_Panels.PanelLogin;
import UI_Panels.PanelNews;
import UI_Panels.PanelPopular;
import UI_Panels.PanelProduct;
import UI_Panels.PanelRecent;
import UI_Panels.PanelSelection;

public class FrameSelection extends JFrame  implements WindowListener{

	private static final long serialVersionUID = 1L;
	private CardLayout cl;
	private JTabbedPane tab_layer;
	public PanelPopular panelPopular;
	public PanelRecent panelRecent;
	public PanelHistory panelHistory;
	private PanelNews panelNews;
	private JPanel centerPanel;
	private JPanel mainPanel;
	public PanelLogin loginPanel;
	public PanelSelection panelSelection;
	private Font myFont;
	public SocketThread st;
	public FrameDisplay displayFrame;
	public String ipAddr;
	public UserInformation userInformation;
	public MainFrameListener mflistener;
	
	public FrameSelection() {

		super("ڵ ");
		this.setLocation(new Point(835, 95));
		this.sub();

	}

	public void sub() {
		this.setSize(new Dimension(310, 623));
		this.setLayout(null);
		this.setVisible(true);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
				
		this.centerPanel = new JPanel();
		cl = new CardLayout();
		centerPanel.setLayout(cl);
		//centerPanel.setSize(new Dimension(250, 623));
		centerPanel.setBounds(new Rectangle(0,0,310,623));
		this.loginPanel = new PanelLogin(this);
		centerPanel.add("loginPanel",loginPanel);
		this.mainPanel = new JPanel();
		mainPanel.setBounds(new Rectangle(0, 0, 310, 623));
		mainPanel.setLayout(null);
		centerPanel.add("mainPanel",mainPanel);
		this.add(centerPanel);
		myFont = new Font(" ", Font.PLAIN, 10);
		mflistener = new MainFrameListener(this);
		tab_layer = new JTabbedPane();
		tab_layer.setFont(myFont);
		
		tab_layer.setBounds(new Rectangle(0, 0, 310, 600));
		mainPanel.add(this.tab_layer);
		
		
		panelSelection = new PanelSelection(this);
		this.tab_layer.add("", panelSelection);
		panelPopular = new PanelPopular();
		panelPopular.addComponentListener(new TabFocus(this));
		this.tab_layer.add("αǰ", panelPopular);
		panelRecent = new PanelRecent();
		panelRecent.addComponentListener(new TabFocus(this));
		this.tab_layer.add("Żǰ", panelRecent);
		//panelTrend = new PanelTrend();
		//this.tab_layer.add("", panelTrend);
		panelHistory = new PanelHistory();
		this.tab_layer.add("History", panelHistory);
		panelNews = new PanelNews();
		panelNews.addComponentListener(new TabFocus(this));
		this.tab_layer.add("мǴ", panelNews);
		
		this.addWindowListener(this);
		
		
		
		InetAddress local = null; 
		
		try {
			local = InetAddress.getLocalHost();
			this.ipAddr = local.getHostAddress();
		} catch (UnknownHostException e) {
			e.printStackTrace();
		}
		
		System.out.println(ipAddr);
		this.st = new SocketThread(this ,ipAddr);
		st.start();
		
		
		
		this.cl.show(this.centerPanel, "loginPanel");
		this.loginPanel.validate();
		this.loginPanel.repaint();
	}
	
	public void setUserInformation(UserInformation user){
		this.userInformation = user;
		
		if(this.userInformation != null){
			//this.st.sendUserInformation(user);
			System.out.println(user.getUserId());
		}
	}
	
	public void swapCard(String str){
		if(str.equals("listPanel")){
			
			this.setTitle("ڵ ");
		}
		this.cl.show(centerPanel, str);
		if(str.equals("mainPanel")){
			this.displayFrame = new FrameDisplay(this);
		}
	}
	
	public void sendUser(UserInfo user){
		this.st.sendUser(user);
	}
	
	public void sendUserInformation(UserInformation user){
		this.st.sendUserInformation(user);
	}
	
	public void close(){
		this.st.close();
	}
	public void windowActivated(WindowEvent arg0) {}
	public void windowClosed(WindowEvent arg0) {}
	public void windowClosing(WindowEvent arg0) {
		this.close();
	}
	public void windowDeactivated(WindowEvent arg0) {}
	public void windowDeiconified(WindowEvent arg0) {}
	public void windowIconified(WindowEvent arg0) {}
	public void windowOpened(WindowEvent arg0) {}
	
	public class TabFocus implements ComponentListener{
		private FrameSelection fs;
		
		public TabFocus(FrameSelection frameSelection){
			this.fs = frameSelection;
			
		}

		public void componentHidden(ComponentEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void componentMoved(ComponentEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void componentResized(ComponentEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		public void componentShown(ComponentEvent ce) {
			Object o = ce.getSource();
			if(o == panelRecent){
				PanelProduct pp = panelRecent.panelProduct[0];
				Product p = pp.getProdut();
				if(p == null){
					fs.st.requestRecent();
				}
			}
			else if(o == panelPopular){
				System.out.println("aaaaaa");
				PanelProduct pp = panelPopular.panelProduct[0];
				Product p = pp.getProdut();
				if(p == null){
					fs.st.requestPopularProduct();
				}
			}
			
		}
		
	}
	
	@SuppressWarnings("static-access")
	public static void main(String args[]){
		NimRODTheme nt = new NimRODTheme();
		nt.setBlack(new Color(200,200,200));
		nt.setWhite(new Color(113,113,113));
		nt.setSecondary(new Color(79,79,79));
		nt.setPrimary(new Color(51,66,78));
		nt.setMenuOpacity(0);
		
		NimRODLookAndFeel nimrodlf = new NimRODLookAndFeel();
		
		nimrodlf.setCurrentTheme(nt);
		try {
			UIManager.setLookAndFeel(nimrodlf);
		} catch (UnsupportedLookAndFeelException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		new FrameSelection();
		
	}
}
