package UI_Panels;

import java.awt.GraphicsConfiguration;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;
import java.awt.image.BufferedImage;
import java.util.Vector;

import javax.media.j3d.AmbientLight;
import javax.media.j3d.Appearance;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.Bounds;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.ColoringAttributes;
import javax.media.j3d.DirectionalLight;
import javax.media.j3d.Locale;
import javax.media.j3d.PhysicalBody;
import javax.media.j3d.PhysicalEnvironment;
import javax.media.j3d.TexCoordGeneration;
import javax.media.j3d.Texture;
import javax.media.j3d.Texture2D;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.View;
import javax.media.j3d.ViewPlatform;
import javax.media.j3d.VirtualUniverse;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.vecmath.AxisAngle4f;
import javax.vecmath.Color3f;
import javax.vecmath.Point3d;
import javax.vecmath.Vector3f;
import javax.vecmath.Vector4f;

import Element.Order;
import Element.ProductSt;

import UI_Frames.FrameDisplay;
import UI_PopUp.ViewProduct;

import com.sun.j3d.utils.geometry.Box;
import com.sun.j3d.utils.geometry.Primitive;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.picking.PickCanvas;
import com.sun.j3d.utils.picking.PickResult;
import com.sun.j3d.utils.universe.SimpleUniverse;


public class Panel3D extends JPanel{
	private static final long serialVersionUID = 1L;
	private GraphicsConfiguration config;
	private Canvas3D canvas3D;
	private Locale locale;
	private VirtualUniverse universe;
	private PhysicalBody body;
	PhysicalEnvironment environment;
	private Vector<ProductSt> list;
	private BranchGroup contentBranch;
	private TransformGroup vpTransGr;
	private TransformGroup contentsTransGr;
	
	//ؽ ο ʿ 
	private Texture2D texture;
	TextureLoader texLoader;
	private boolean enable = true;
	private int texBoundaryModeS = Texture.WRAP;
	private int texBoundaryModeT = Texture.WRAP;
	
	private int texMinFilter = Texture.NICEST;
	private int texMagFilter = Texture.NICEST;
	
	private TexCoordGeneration texGen;
	
	private Vector4f texGenPlaneS = new Vector4f(1.0f, 0.0f, 2.0f, 0.0f);
	private Vector4f texGenPlaneT = new Vector4f(0.0f, 1.0f, -5.0f, 0.0f);
	
	private BranchGroup viewBranch;
	private ViewPlatform viewPlatform;
	
	private Bounds bounds;
	private View view;
	private Point oldP = new Point();
	private Point newP = new Point();
	private AxisAngle4f rotateAxisAngle,rotateObjAxisAngle;
	private Vector3f rotateAxis = new Vector3f(0.0f,1.0f,0.0f);
	private float rightRotateAngle = 1.57f;
	private float leftRotateAngle = -1.57f;
	private Transform3D tmpTrans = new Transform3D();
	private Transform3D[] tmpObjTrans = new Transform3D[4];
	private TransformGroup[] tfg = new TransformGroup[4];
	private TransformGroup[] rotTfg = new TransformGroup[4];
	private TransformGroup[] posTfg = new TransformGroup[4];
	private Appearance[] app = new Appearance[4];
	private Box[] box = new Box[4];
	private FrameDisplay displayFrame;

	private int rIndex,left,center,right;
	private float cntViewZ=3.3f;
	private PickCanvas pc;
	private ViewProduct viewProduct;
	private Boolean isTextured = false;
	
	public Panel3D(FrameDisplay displayFrame){
		this.displayFrame = displayFrame;
		this.sub();

		
	}
	
	
	public ViewProduct getViewProduct(){
		return this.viewProduct;
	}
	
	@SuppressWarnings("static-access")
	private void sub() {
		this.setSize(694,461);
		this.setBorder(BorderFactory.createLoweredBevelBorder());
		config = SimpleUniverse.getPreferredConfiguration();
		canvas3D = new Canvas3D(config);
		canvas3D.setBounds(new Rectangle(0,0,694,461));
		
		this.setLayout(null);
		this.add(canvas3D);

		bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), Double.MAX_VALUE);
		
		setUniverse();
		setContent();
		setView();
		
		pc = new PickCanvas(canvas3D,contentBranch);
		pc.setMode(pc.BOUNDS);
		canvas3D.addMouseListener(new SpinHandler2(this));
		canvas3D.addMouseMotionListener(new SpinHandler1());
		this.canvas3D.addMouseWheelListener(new ZoomHandler());
		viewProduct = new ViewProduct(this.displayFrame);
		
		
		rotateAxisAngle = new AxisAngle4f(rotateAxis,0.0f);
		rotateObjAxisAngle = new AxisAngle4f(rotateAxis,0.0f);
		for(int i=0;i<4;i++){
			tmpObjTrans[i] = new Transform3D();
		}
		
	}
	
	public void setUniverse()
    {
        universe = new VirtualUniverse();
        locale = new Locale(universe);
        
    }
	
	public void setContent(){
		contentsTransGr = new TransformGroup();
        contentsTransGr.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        contentsTransGr.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
        
        for(int j=0;j<4;j++){
        	rotTfg[j] = new TransformGroup();
        	tfg[j] = new TransformGroup();
        }
        
        setLight();
        
        for(int i=0;i<4;i++){
        	app[i] = new Appearance();
        	app[i].setCapability(Appearance.ALLOW_TEXGEN_WRITE);
        	app[i].setCapability(Appearance.ALLOW_TEXTURE_WRITE);
        }
        
        
   
        app[0].setColoringAttributes(new ColoringAttributes(new Color3f(0.1f,0.1f,0.1f),1)); 
    
        box[0] = new Box(0.25f,0.5f,0.1f,Box.GENERATE_TEXTURE_COORDS,app[0]);
        box[0].setName("box0");
        box[0].setCapability(Box.ALLOW_PICKABLE_WRITE);
        
        rotTfg[0].addChild(box[0]);
        Transform3D t1 = new Transform3D();
        t1.setTranslation(new Vector3f(0.0f,0.2f,0.7f));
        
        posTfg[0] = new TransformGroup(t1);
        posTfg[0].addChild(rotTfg[0]);
        tfg[0].addChild(posTfg[0]);
        
        
        
        contentsTransGr.addChild(tfg[0]);
        
        app[1].setColoringAttributes(new ColoringAttributes(new Color3f(0.1f,0.1f,0.1f),1));
    
        box[1] = new Box(0.25f,0.5f,0.1f,Box.GENERATE_TEXTURE_COORDS,app[1]);
        box[1].setName("box1");
        box[1].setCapability(Box.ALLOW_PICKABLE_WRITE);
        
        rotTfg[1].addChild(box[1]);
        
        t1.setTranslation(new Vector3f(-0.7f,0.2f,0.0f));
        posTfg[1] = new TransformGroup(t1);
        posTfg[1].addChild(rotTfg[1]);
        
        tfg[1].addChild(posTfg[1]);
        
        contentsTransGr.addChild(tfg[1]);
        
        app[2].setColoringAttributes(new ColoringAttributes(new Color3f(0.1f,0.1f,0.1f),1));
   
        box[2] = new Box(0.25f,0.5f,0.1f,Box.GENERATE_TEXTURE_COORDS,app[2]);
        box[2].setName("box2");
        box[2].setCapability(Box.ALLOW_PICKABLE_WRITE);
        
        rotTfg[2].addChild(box[2]);
        
        t1.setTranslation(new Vector3f(0.0f,0.2f,-0.7f));
        posTfg[2] = new TransformGroup(t1);
        posTfg[2].addChild(rotTfg[2]);
        
        tfg[2].addChild(posTfg[2]);
        
        contentsTransGr.addChild(tfg[2]);
        
        app[3].setColoringAttributes(new ColoringAttributes(new Color3f(0.1f,0.1f,0.1f),1));
  
        box[3] = new Box(0.25f,0.5f,0.1f,Box.GENERATE_TEXTURE_COORDS,app[3]);
        box[3].setName("box3");
        box[3].setCapability(Box.ALLOW_PICKABLE_WRITE);
        
        
        rotTfg[3].addChild(box[3]);
        
        t1.setTranslation(new Vector3f(0.7f,0.2f,0.0f));
        posTfg[3] = new TransformGroup(t1);
        posTfg[3].addChild(rotTfg[3]);
        
        tfg[3].addChild(posTfg[3]);
        
        contentsTransGr.addChild(tfg[3]);
        
        rIndex = 2;
        this.left= 1;
        this.center =0;
        this.right = 3;
        
        box[rIndex].setPickable(false);
		box[left].setPickable(false);
		box[right].setPickable(false);
		box[center].setPickable(true);
        
      for(int i=0;i<4;i++){
		tfg[i].setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		tfg[i].setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		rotTfg[i].setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		rotTfg[i].setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
      }
        
        
        contentBranch = new BranchGroup();
        contentBranch.addChild(contentsTransGr);// Compiling the branch graph before making it live
        contentBranch .compile();
        locale.addBranchGraph(contentBranch);
        
	}
	
	
	public void setProductList(Vector<ProductSt> list){
		this.list = list;
		this.viewProduct.setProductSet(list.elementAt(1));
	}
	
	
	public void setView(){
		viewBranch = new BranchGroup();
		
		viewPlatform = new ViewPlatform();
        viewPlatform.setActivationRadius(Float.MAX_VALUE);
        viewPlatform.setBounds(bounds);
        
        Transform3D t = new Transform3D();
        
        
        t.set(new Vector3f(0.0f, 0.3f, 3.3f));
        vpTransGr = new TransformGroup(t);
        
        
        vpTransGr.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        vpTransGr.setCapability( TransformGroup.ALLOW_TRANSFORM_READ);

        vpTransGr.addChild(viewPlatform);
        viewBranch.addChild(vpTransGr);
        
        view = new View();
        view.setProjectionPolicy(View.PERSPECTIVE_PROJECTION );
        
        view.addCanvas3D(canvas3D);
  		
        body = new PhysicalBody();
        view.setPhysicalBody(body);
        environment = new PhysicalEnvironment();
        view.setPhysicalEnvironment(environment);
        
        view.attachViewPlatform(viewPlatform);
        view.setWindowResizePolicy(View.PHYSICAL_WORLD);

  
        locale.addBranchGraph(viewBranch);
	}
	
	public void setLight(){
		AmbientLight ambientLight =  new AmbientLight();
        ambientLight.setEnable(true);
        ambientLight.setColor(new Color3f(0.10f, 0.1f, 1.0f) );
        ambientLight.setCapability(AmbientLight.ALLOW_STATE_READ);
        ambientLight.setCapability(AmbientLight.ALLOW_STATE_WRITE);
        ambientLight.setInfluencingBounds(bounds);
        contentsTransGr.addChild(ambientLight);

        DirectionalLight dirLight =  new DirectionalLight();
        dirLight.setEnable(true);
        dirLight.setColor( new Color3f( 1.0f, 0.0f, 0.0f ) );
        dirLight.setDirection( new Vector3f( 1.0f, -0.5f, -0.5f ) );
        dirLight.setCapability( AmbientLight.ALLOW_STATE_WRITE );
        dirLight.setInfluencingBounds(bounds);
        contentsTransGr.addChild(dirLight);
	}
	
	public void initialTexture(BufferedImage [] imageArr){
		setTexture(app[left],imageArr[0]);
		setTexture(app[center],imageArr[1]);
		setTexture(app[right],imageArr[2]);
		isTextured = true;
		
	}
	
	public void setProductTexture(BufferedImage image,ProductSt ps) {
		this.setTexture(app[this.rIndex], image);
		
		if(ps.getIsNext().equals("true")){
			if(this.list !=null){
				this.list.remove(2);
				Vector<ProductSt> list2 = new Vector<ProductSt>();
				list2.add(ps);
				list2.add(list.elementAt(0));
				list2.add(list.elementAt(1));
				this.list.removeAllElements();
				this.list = list2;
				this.viewProduct.setProductSet(list.get(1));
				
			}
			setRotation(rightRotateAngle,0.0f);//ȸ 
			if(rIndex==3){
				rIndex = 0;
			}else{
				rIndex = rIndex + 1;
			}
			
			if(left==3){
				left = 0;
			}else{
				left = left + 1;
			}
			
			if(center==3){
				center = 0;
			}else{
				center = center + 1;
			}
			
			if(right==3){
				right = 0;
			}else{
				right = right + 1;
			}
			box[rIndex].setPickable(false);
			box[left].setPickable(false);
			box[right].setPickable(false);
			box[center].setPickable(true);
		}else{
			if(this.list !=null){
				this.list.remove(0);
				Vector<ProductSt> list2 = new Vector<ProductSt>();
				
				list2.add(list.elementAt(0));
				list2.add(list.elementAt(1));
				list2.add(ps);
				this.list.removeAllElements();
				this.list = list2;
				this.viewProduct.setProductSet(list.elementAt(1));
				
			}
			setRotation(leftRotateAngle,0.0f);
			if(rIndex==0){
				rIndex = 3;
			}else{
				rIndex = rIndex - 1;
			}
			
			if(left==0){
				left = 3;
			}else{
				left = left - 1;
			}
			
			
			if(center==0){
				center = 3;
			}else{
				center = center - 1;
			}
			
			if(right==0){
				right = 3;
			}else{
				right = right - 1;
			}
			box[rIndex].setPickable(false);
			box[left].setPickable(false);
			box[right].setPickable(false);
			box[center].setPickable(true);
		}
	}
	
	public void setTexture(Appearance app,BufferedImage image){
		
		texLoader = new TextureLoader(image);
		texture = (Texture2D) texLoader.getTexture();
	    texture.setBoundaryModeS(texBoundaryModeS);
	    texture.setBoundaryModeT(texBoundaryModeT);
	    texture.setEnable(enable);
	    texture.setMinFilter(texMinFilter);
	    texture.setMagFilter(texMagFilter);
	    texGen = new TexCoordGeneration(TexCoordGeneration.OBJECT_LINEAR,TexCoordGeneration.TEXTURE_COORDINATE_2,texGenPlaneS,texGenPlaneT);
	    texture.setCapability(Texture.ALLOW_ENABLE_WRITE);
	    texture.setCapability(Texture.ALLOW_IMAGE_WRITE);
	    
	    
	    texGen.setCapability(TexCoordGeneration.ALLOW_ENABLE_WRITE);
	    texGen.setCapability(TexCoordGeneration.ALLOW_ENABLE_READ);
	    texGen.setEnable(enable);
	    app.setTexCoordGeneration(texGen);
	    app.setTexture(texture);
	    
	}
	
	
	
	public void setRotation(float angle,float j){
		long time = System.currentTimeMillis();
		float orinAngle = rotateAxisAngle.angle;
		float oldAnlge = rotateObjAxisAngle.angle;
		while(true){
			long current = System.currentTimeMillis();
			if((current - time)>1000){
				if(angle>0){
					rotateAxisAngle.angle = (float)(orinAngle + Math.PI/2);
					rotateObjAxisAngle.angle = (float)(oldAnlge - Math.PI/2);
					
				}
				else{
					rotateAxisAngle.angle = (float)(orinAngle - Math.PI/2);
					rotateObjAxisAngle.angle = (float)(oldAnlge + Math.PI/2);
				}
				
				contentsTransGr.getTransform(tmpTrans);
				
				rotTfg[0].getTransform(tmpObjTrans[0]);
				rotTfg[1].getTransform(tmpObjTrans[1]);
				rotTfg[2].getTransform(tmpObjTrans[2]);
				rotTfg[3].getTransform(tmpObjTrans[3]);
				tmpTrans.setRotation(rotateAxisAngle);
				
				
				tmpObjTrans[0].setRotation(rotateObjAxisAngle);
				tmpObjTrans[1].setRotation(rotateObjAxisAngle);
				tmpObjTrans[2].setRotation(rotateObjAxisAngle);
				tmpObjTrans[3].setRotation(rotateObjAxisAngle);
				
				contentsTransGr.setTransform(tmpTrans);
				rotTfg[0].setTransform(tmpObjTrans[0]);
				rotTfg[1].setTransform(tmpObjTrans[1]);
				rotTfg[2].setTransform(tmpObjTrans[2]);
				rotTfg[3].setTransform(tmpObjTrans[3]);
				break;
			}
			try {
				Thread.sleep(10);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			
			if(angle>0){
				rotateAxisAngle.angle += 1.57079/90;
				rotateObjAxisAngle.angle -= 1.57079/90;
			}
			else{
				rotateAxisAngle.angle -= 1.57079/90;
				rotateObjAxisAngle.angle += 1.57079/90;
			}
			
			
			contentsTransGr.getTransform(tmpTrans);
			
			rotTfg[0].getTransform(tmpObjTrans[0]);
			rotTfg[1].getTransform(tmpObjTrans[1]);
			rotTfg[2].getTransform(tmpObjTrans[2]);
			rotTfg[3].getTransform(tmpObjTrans[3]);
			tmpTrans.setRotation(rotateAxisAngle);
			
			tmpObjTrans[0].setRotation(rotateObjAxisAngle);
			tmpObjTrans[1].setRotation(rotateObjAxisAngle);
			tmpObjTrans[2].setRotation(rotateObjAxisAngle);
			tmpObjTrans[3].setRotation(rotateObjAxisAngle);
			
			contentsTransGr.setTransform(tmpTrans);
			rotTfg[0].setTransform(tmpObjTrans[0]);
			rotTfg[1].setTransform(tmpObjTrans[1]);
			rotTfg[2].setTransform(tmpObjTrans[2]);
			rotTfg[3].setTransform(tmpObjTrans[3]);
			
			
		}
		
		
	}
	
	public class ZoomHandler implements MouseWheelListener{
		

		public void mouseWheelMoved(MouseWheelEvent we){
			Transform3D tmp = new Transform3D();
			if(we.getWheelRotation()>0){
				cntViewZ = cntViewZ + we.getWheelRotation()/50.0f;
				vpTransGr.getTransform(tmp);
				tmp.set(new Vector3f(0.0f,0.3f,cntViewZ));
				vpTransGr.setTransform(tmp);
				//System.out.println(cntViewZ);
			
				
			}
			else if(we.getWheelRotation()<0){
				cntViewZ = cntViewZ + we.getWheelRotation()/50.0f;
				vpTransGr.getTransform(tmp);
				tmp.set(new Vector3f(0.0f,0.3f,cntViewZ));
				vpTransGr.setTransform(tmp);
				//System.out.println(cntViewZ);
			}
			else{
				
			}
		}
	}
	
	
	public class SpinHandler1 extends MouseMotionAdapter{
		public void mouseDragged(MouseEvent me){}
		
		
	}
	
	public class SpinHandler2 extends MouseAdapter{
		Panel3D p3d;
		public SpinHandler2(Panel3D panel3D) {
			this.p3d = panel3D;
		}

		public void mousePressed(MouseEvent me){
			oldP.x = me.getX();
			oldP.y = me.getY();
		}
		
		@SuppressWarnings("static-access")
		public void mouseReleased(MouseEvent me){
			newP = me.getPoint();
			if(me.getButton()==me.BUTTON1){
				if((oldP.x-newP.x)<0){
					displayFrame.selectionFrame.st.sendOrder(new Order(true));
				}
				else if((oldP.x-newP.x)>0){
					displayFrame.selectionFrame.st.sendOrder(new Order(false));
				}
				
			}
			else if(me.getButton()==me.BUTTON3){
				if(isTextured == true){
					pc.setShapeLocation(me);
					PickResult pr = pc.pickClosest();
					if(pr==null){
						System.out.println("nothing picked");
					}
					else{
						Primitive p = (Primitive)pr.getNode(PickResult.PRIMITIVE);
						if(p != null){
							//System.out.println(p.getName());
							
							viewProduct.show(p3d.canvas3D,me.getX() , me.getY()-250);
							System.out.println(me.getX()+","+me.getY());
						}
					}
				}
				
			}
			
		}
	}

	
}
