package UI_Panels;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JPanel;
import UI_Frames.FrameDisplay;
import Element.Product;
import Element.ProductSt;
import Handlers.DisplayPanelListener;

public class PanelDisplay extends JPanel  {

	private static final long serialVersionUID = 1L;
	public JButton left, right;
	public Vector<Product> vector;
	@SuppressWarnings("unused")
	public FrameDisplay displayFrame;
	private boolean isNext;
	private DisplayPanelListener dl;
	@SuppressWarnings("unused")
	private Vector<ProductSt> list;
	public Panel3D Panel_3d;
	
	private Image image;
	//private ImageProducer producer;
	private MediaTracker tracker;
		
	public PanelDisplay(FrameDisplay displayFrame) {
		this.displayFrame = displayFrame;
		Panel_3d = new Panel3D(this.displayFrame);
		this.addMouseListener(dl);
		vector = new Vector<Product>();
		list = new Vector<ProductSt>();
		this.setLayout(null);
		dl = new DisplayPanelListener(this);
		
		tracker = new MediaTracker(this);
		image = getToolkit().getImage("images/.gif");
		tracker.addImage(image, 0);
		
		try {
			tracker.waitForAll();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
		this.add(Panel_3d);
	}
	
	public void paint(Graphics g) {
		super.paint(g);
		if(image != null){
			g.drawImage(image,0, 461, 700, 120, this);
		}
		//if((tracker.statusAll(true) & MediaTracker.COMPLETE) !=0)
			//g.drawImage(image,0,461,this);
	}
	
	public void addProduct(Product product){
		this.vector.add(product);
	}
	
	
	public Panel3D getPanel3D(){
		return this.Panel_3d;
	}
	
	
	public void setProductList(ArrayList<ProductSt> pl){ // ù°   ǰ  ÷ 
	BufferedImage [] imageArr = new BufferedImage[3];
	
	for(int i=0;i<pl.size();i++){
		 imageArr[i] = new BufferedImage(500, 900,BufferedImage.TYPE_4BYTE_ABGR);
		 Graphics2D g = (Graphics2D) imageArr[i].getGraphics();
		 g.setRenderingHint(RenderingHints.KEY_FRACTIONALMETRICS, RenderingHints.VALUE_FRACTIONALMETRICS_ON);
		 g.setColor(Color.white);
		 g.fillRect(0, 0, 500, 900);
		 
		
		 g.drawImage(pl.get(i).getTop().getImage(), 0,20, 200,300, this);
		 g.drawImage(pl.get(i).getBottom().getImage(), 0, 330, 200,300, this);
		 g.drawImage(pl.get(i).getAccessary().getImage(), 0, 650, 200, 240, this);
	}
	this.Panel_3d.initialTexture(imageArr);
	Vector<ProductSt> vector = new Vector<ProductSt>();
	vector.add(pl.get(0));
	vector.add(pl.get(1));
	vector.add(pl.get(2));
	
	this.Panel_3d.setProductList(vector);
	}
	
	public void setProductTexture(ProductSt ps) {
		ProductSt p = (ProductSt)ps;
		BufferedImage image = new BufferedImage(500, 900,BufferedImage.TYPE_4BYTE_ABGR);
		Graphics2D g = (Graphics2D) image.getGraphics();
		g.setColor(Color.white);
		g.fillRect(0, 0, 500, 900);
	 
		g.drawImage(p.getTop().getImage(), 0,20, 200,300, this);
		g.drawImage(p.getBottom().getImage(), 0, 330, 200,300, this);
		g.drawImage(p.getAccessary().getImage(), 0, 650, 200, 240, this);
		
		this.Panel_3d.setProductTexture(image, p);
	}
	public void sendOrder(){
		
	}
	
	
	public void displayProduct(){
		if(this.isNext ==true){// face to next
			
		}else{                 // face to forward
			
		}
		this.repaint();
	}

	
	

}
