package UI_Panels;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import UI_Frames.FrameAddRSS;

import Element.RssPackage;

public class PanelNews extends JPanel implements ActionListener,MouseListener{
	private static final long serialVersionUID = 1L;
	private JList newsList;
	private DefaultListModel listModel;
	private JScrollPane sp1;
	private JButton bt_addRss;
	private PanelContents[] panelContents;
	private JPanel panel;
	private JScrollPane scroll;
	private Vector<RssPackage> vector;
	
	public PanelNews() {
		super();
		vector = new Vector<RssPackage>();
		this.listModel = new DefaultListModel();
		this.newsList = new JList(listModel);
		newsList.addMouseListener(this);
		this.sp1 = new JScrollPane(newsList);
		
		bt_addRss = new JButton("RSS  ߰");
		bt_addRss.addActionListener(this);			
		panelContents = new PanelContents[15];
		
		panel = new JPanel();
		scroll = new JScrollPane(panel);
		RssPackage rp = new RssPackage("Ÿ ǰ  " , "http://blog.rss.naver.com/kimiusa.xml");
		vector.add(rp);
		
		for(int i=0 ; i<15 ; i++) {		
			panelContents[i] = new PanelContents();	
			panel.add(panelContents[i]);
			
		}
		listModel.addElement(rp.getSiteName());
		this.sub();
	}
	
	public void sub() {
		this.setBounds(new Rectangle(0,0,300,560));
		this.setLayout(null);
				
		this.sp1.setBounds(new Rectangle(3,3,293,190));
		sp1.setBorder(BorderFactory.createLoweredBevelBorder());
		this.add(sp1);	
		
		bt_addRss.setBounds(new Rectangle(185,203,110,25));
		this.add(bt_addRss);
		
		panel.setLayout(new GridLayout(15,1));
		panel.setPreferredSize(new Dimension(210,2000));//1430
		panel.setBackground(Color.DARK_GRAY);
		
		scroll.setBounds(new Rectangle(3,238,293,309));
		scroll.setBorder(BorderFactory.createLoweredBevelBorder());
		this.add(scroll);		
	}
	
	public void addRss(RssPackage rp){
		this.vector.add(rp);
		listModel.addElement(rp.getSiteName());
	}

	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		if(o == this.bt_addRss){
			new FrameAddRSS(this);
		}
		
	}

	public void mouseClicked(MouseEvent e) {
		int count = e.getClickCount();
		if(count == 2){
			String str = (String)this.newsList.getSelectedValue();

			for(int i=0;i<this.vector.size();i++){
				if(this.vector.elementAt(i).getSiteName().equals(str)){
					DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
					factory.setIgnoringElementContentWhitespace(true); // 
					DocumentBuilder builder= null;
					try {
						builder = factory.newDocumentBuilder();
					} catch (ParserConfigurationException e1) {
						e1.printStackTrace();
					}
					
					 
					
					// XML  Ľϱ
					Document document = null;
					try {
						System.out.println(":"+vector.elementAt(i).getSiteLink()+":");
						document = builder.parse(vector.elementAt(i).getSiteLink());
						
					} catch (SAXException e1) {
						e1.printStackTrace();
					} catch (IOException e1) {
						e1.printStackTrace();
					}
					if(document.getDocumentElement() == null){}
					else{
					Element eRoot = document.getDocumentElement();
					NodeList nlTitles = eRoot.getElementsByTagName("item");
					int items = nlTitles.getLength();
					
					for(int j=0; j<items && j<this.panelContents.length ; j++){
					
						  Element eTitle = (Element)nlTitles.item(j);
						  NodeList nodeList = eTitle.getChildNodes();
						  for(int k=0 ;k < nodeList.getLength();k++){
							  if(nodeList.item(k).getNodeName().equals("title")){
								  this.panelContents[j].setTitle(nodeList.item(k).getTextContent());
							  }else if(nodeList.item(k).getNodeName().equals("description")){
								  
								  String content = nodeList.item(k).getTextContent();
								  String description = content.replaceAll("&nbsp;", "");
								  this.panelContents[j].setDescription(description);
							  }else if(nodeList.item(k).getNodeName().equals("link")){
								  this.panelContents[j].setLink(nodeList.item(k).getTextContent());
							  }else if(nodeList.item(k).getNodeName().equals("pubDate")){
								  String date = nodeList.item(k).getTextContent();
								  date = date.substring(0, date.length()-15);
								  this.panelContents[j].setDate(date);
							  }
							  
							
							 
						  }
						  
					  } 
	
					}
				}
			}
			
		}
	}

	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
}
