package UI_Panels;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Point;
import java.awt.RenderingHints;
import java.util.Vector;
import javax.swing.JPanel;

import Element.Element;
import Element.UserPreference;
import Handlers.PentagonListener;

public class PanelPentagon extends JPanel{
	private static final long serialVersionUID = 1L;

	private Element price, brand, activity, colorful, splendor;
	
	private Image bgImage=null;
	private MediaTracker tracker;

	public Vector<Element> vector;
	public UserPreference UPr;

	public PanelPentagon() {
		this.vector = new Vector<Element>();
		this.setLayout(null);
		
		UPr = new UserPreference((int)9,(int)9,(int)9,(int)9,(int)9) ;
		price = new Element("price");
		price.setPositon(new Point(150, 130), new Point(150, 30));
		brand = new Element("brand");
		brand.setPositon(new Point(150, 130), new Point(55, 98));
		activity = new Element("activity");
		activity.setPositon(new Point(150, 130), new Point(245, 98));
		colorful = new Element("colorful");
		colorful.setPositon(new Point(150, 130), new Point(91, 210));
		splendor = new Element("splendor");
		splendor.setPositon(new Point(150, 130), new Point(208, 210));
		
		bgImage = this.getToolkit().getImage("images/pentagon.png");
		tracker = new MediaTracker(this);
		tracker.addImage(bgImage, 0);
		try {
			tracker.waitForAll();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		repaint();
		vector.add(price);
		vector.add(activity);
		vector.add(splendor);
		vector.add(colorful);
		vector.add(brand);

		this.addMouseListener(new PentagonListener(this));

	}

	public void paint(Graphics g) {
		super.paint(g);
		Graphics2D g2d = (Graphics2D) g;
		g2d.setColor(Color.white);
		g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);
		g2d.drawOval(95, 95, 10, 10);
		if((tracker.statusAll(true) & MediaTracker.COMPLETE) !=0){
			g2d.drawImage(bgImage,50,30,this);
		}

		for (int i = 0; i < vector.size(); i++) {
			vector.elementAt(i).paint(g2d);
			if (i == 0) {
				g2d.drawLine(vector.elementAt(4).getEllipsePoint().x, vector
						.elementAt(4).getEllipsePoint().y, vector.elementAt(i)
						.getEllipsePoint().x, vector.elementAt(i)
						.getEllipsePoint().y);
				g2d.drawLine(vector.elementAt(i).getEllipsePoint().x, vector
						.elementAt(i).getEllipsePoint().y, vector.elementAt(1)
						.getEllipsePoint().x, vector.elementAt(1)
						.getEllipsePoint().y);

			} else if (i == 4) {
				g2d.drawLine(vector.elementAt(4).getEllipsePoint().x, vector
						.elementAt(4).getEllipsePoint().y, vector.elementAt(3)
						.getEllipsePoint().x, vector.elementAt(3)
						.getEllipsePoint().y);
			} else {
				g2d.drawLine(vector.elementAt(i - 1).getEllipsePoint().x,
						vector.elementAt(i - 1).getEllipsePoint().y, vector
								.elementAt(i).getEllipsePoint().x, vector
								.elementAt(i).getEllipsePoint().y);
				g2d.drawLine(vector.elementAt(i + 1).getEllipsePoint().x,
						vector.elementAt(i + 1).getEllipsePoint().y, vector
								.elementAt(i).getEllipsePoint().x, vector
								.elementAt(i).getEllipsePoint().y);

			}
		}

		g2d.drawOval(50, 30, 200, 200);
	}

	
}
