package Communication;


import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Toolkit;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Vector;

import Element.ElementImage;
import Element.Order;
import Element.Product;
import Element.ProductSt;
import Element.Recommendation;
import Element.UserInfo;
import Element.UserInformation;
import Element.UserPreference;
import Main.MainFrame;

public class ClientHandler extends Thread{
	private Socket clientSocket;
	private boolean stop= true;
	private ObjectInputStream in;
	private ObjectOutputStream out;
	private ArrayList<ProductSt> ProductList;
	private MediaTracker mt;
	private MainFrame mainframe;
	private Toolkit myToolkit;
	private int preProduct=0,postProduct=0;

	
	public ClientHandler(MainFrame mainframe ,Socket s) {
		this.mainframe = mainframe;
		this.clientSocket = s;
		try {
			out = new ObjectOutputStream(clientSocket.getOutputStream());
			in = new ObjectInputStream(clientSocket.getInputStream());
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		myToolkit = Toolkit.getDefaultToolkit();
		mt = new MediaTracker(this.mainframe);
	}
	
	
	public void setProductList(ArrayList<ProductSt> ProductList){
		this.ProductList = ProductList;
	}
	
	public ArrayList<ProductSt>  getProductList(){
		
		return this.ProductList;
		
	}
	
	
	
	public void sendProductList(){
		ArrayList<ProductSt> list = new ArrayList<ProductSt>();
		for(int i=0;i<3;i++){
			list.add(this.ProductList.get(i));
		}
		
		for(int i=0;i<list.size();i++){
			ProductSt ps = list.get(i);
			Image[]  imageArr = new Image[3];
			imageArr[0] = this.myToolkit.getImage(ps.getTop().getImagePath());
			mt.addImage(imageArr[0], 0);
			
			imageArr[1] = this.myToolkit.getImage(ps.getBottom().getImagePath());
			mt.addImage(imageArr[1], 1);
			
			imageArr[2] = this.myToolkit.getImage(ps.getAccessary().getImagePath());
			mt.addImage(imageArr[2], 2);
			
			try {
				mt.waitForAll();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			
			ps.getTop().setImage(imageArr[0]);
			ps.getBottom().setImage(imageArr[1]);
			ps.getAccessary().setImage(imageArr[2]);
			
			ps.getTop().ImageToByte();
			ps.getBottom().ImageToByte();
			ps.getAccessary().ImageToByte();
			
			mt.removeImage(imageArr[0]);
			mt.removeImage(imageArr[1]);
			mt.removeImage(imageArr[2]);
			
			imageArr[0]= null;
			imageArr[1]= null;
			imageArr[2]= null;
		}
		
		try {
			out.writeObject(list);
		} catch (IOException e) {
			e.printStackTrace();
		}
		this.preProduct = 0;
		this.postProduct = 2;
		
	}
	
	public String getRemoteSocketAddress(){
		String str = clientSocket.getRemoteSocketAddress().toString();
		str = str.substring(1);
		int index = str.indexOf(':');
		str = str.substring(0, index);
		return str;
	}
	
	public void sendUser(UserInfo user){
		try {
			out.writeObject(user);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void sendUserInformation(UserInformation user){
		try {
			out.writeObject(user);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void sendProductSet(Order order){
		
		if(this.ProductList != null){
		if(!order.getIsNext()){
			if(this.postProduct+1 < this.ProductList.size()){
				try {
					ProductSt ps = ProductList.get(postProduct+1);
					ps.setIsNext("false");
					Image[]  imageArr = new Image[3];
					imageArr[0] = this.myToolkit.getImage(ps.getTop().getImagePath());
					mt.addImage(imageArr[0], 0);
					
					imageArr[1] = this.myToolkit.getImage(ps.getBottom().getImagePath());
					mt.addImage(imageArr[1], 1);
					
					imageArr[2] = this.myToolkit.getImage(ps.getAccessary().getImagePath());
					mt.addImage(imageArr[2], 2);
					
					try {
						mt.waitForAll();
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				
					ps.getTop().setImage(imageArr[0]);
					ps.getBottom().setImage(imageArr[1]);
					ps.getAccessary().setImage(imageArr[2]);
					
					ps.getTop().ImageToByte();
					ps.getBottom().ImageToByte();
					ps.getAccessary().ImageToByte();
					
					mt.removeImage(imageArr[0]);
					mt.removeImage(imageArr[1]);
					mt.removeImage(imageArr[2]);
					
					imageArr[0]= null;
					imageArr[1]= null;
					imageArr[2]= null;
					
					this.out.writeObject(ps);
					
					this.preProduct +=1;
					this.postProduct +=1;
					
					ps.getTop().setIamgePixe(null);
					ps.getAccessary().setIamgePixe(null);
					ps.getBottom().setIamgePixe(null);
					this.out.flush();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}else{
			if(this.preProduct-1 >=0){
				try {
					ProductSt pi = ProductList.get(preProduct-1);
					
				
					
					Image[]  imageArr = new Image[3];
					imageArr[0] = this.myToolkit.getImage(pi.getTop().getImagePath());
					mt.addImage(imageArr[0], 0);
					
					imageArr[1] = this.myToolkit.getImage(pi.getBottom().getImagePath());
					mt.addImage(imageArr[1], 1);
					
					imageArr[2] = this.myToolkit.getImage(pi.getAccessary().getImagePath());
					mt.addImage(imageArr[2], 2);
					
					try {
						mt.waitForAll();
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
					
					pi.getTop().setImage(imageArr[0]);
					pi.getBottom().setImage(imageArr[1]);
					pi.getAccessary().setImage(imageArr[2]);
					
					pi.getTop().ImageToByte();
					pi.getBottom().ImageToByte();
					pi.getAccessary().ImageToByte();
					ProductList.get(preProduct-1).setIsNext("true");
					
					ProductSt p = new ProductSt();
					p.setTop(pi.getTop());
					p.setAccessary(pi.getAccessary());
					p.setBottom(pi.getBottom());
					p.setIsNext(new String("true"));
					
					this.out.writeObject(p);
					
					mt.removeImage(imageArr[0]);
					mt.removeImage(imageArr[1]);
					mt.removeImage(imageArr[2]);
					
					imageArr[0]= null;
					imageArr[1]= null;
					imageArr[2]= null;
					
					this.preProduct -=1;
					this.postProduct -=1;
					
					pi.getTop().setIamgePixe(null);
					pi.getAccessary().setIamgePixe(null);
					pi.getBottom().setIamgePixe(null);
					this.out.flush();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		}
	}
	
	public void sendRecommendedProduct(Vector<Product> rp){
		for(int i=0 ; i<rp.size(); i++){
			Image image = this.myToolkit.createImage(rp.elementAt(i).getImagePath());
			mt.addImage(image, 0);
			try {
				mt.waitForAll();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			rp.elementAt(i).setImage(image);
			rp.elementAt(i).ImageToByte();
			mt.removeImage(image);
		}
		try {
			this.out.writeObject(rp);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void run(){
		while(stop){
			try {
				Object o = in.readObject();
				if(o  instanceof String){
					String str = (String)o;
					if(str.startsWith("end")){
						this.stop = false;
						this.out.writeObject("end");
						this.mainframe.getClientHandlers().remove(this);
					
					}
					else if(str.startsWith("recent")){
						Vector<Product> rp = new Vector<Product>();
						rp = this.mainframe.dbProcess.recentRecommend();
						this.sendRecommendedProduct(rp);
						
					}else if(str.startsWith("popular")){
						Vector<Product> rp = new Vector<Product>();
						rp = this.mainframe.dbProcess.popularRecommend();
						rp.removeElementAt(9);
						this.sendRecommendedProduct(rp);
					}
				}else if(o instanceof ElementImage){
					this.mainframe.drawImage((ElementImage)o);
				}else if(o instanceof UserPreference){
					UserPreference UPf = (UserPreference)o;
					UPf.printValues();
					this.ProductList = this.mainframe.getProductList(UPf);
					sendProductList();
				}else if(o instanceof Order){
					Order order = (Order)o;
					this.sendProductSet(order);
				}else if(o instanceof UserInfo){
					UserInfo user = (UserInfo)o;
					this.mainframe.dbProcess.dupCheck(user);
					//this.mainframe.isCorrectInfo(user);
				}else if(o instanceof UserInformation){
					UserInformation uf = (UserInformation)o; 
					if(uf.getIsSaved()==false){
						this.mainframe.insertUser(uf);
					}
					else{
						this.mainframe.isExist(uf);
					}
					
				}else if(o instanceof Recommendation){
					Recommendation r = (Recommendation)o;
					this.mainframe.dbProcess.bookMark(r);
					//System.out.println(" Ŀ :" + r.getProductNum());
				}
			} catch (IOException e) {
				e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
		}
		try {
			this.in.close();
			this.out.close();
			this.clientSocket.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
