package DB;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;
import Element.Recommendation;
import Element.UserInfo;
import Element.UserInformation;
import Element.UserPreference;
import Element.Product;
import Main.MainFrame;

import com.mysql.jdbc.ResultSetMetaData;

public class DBProcess {
	
	private Connection con;
	private String jdbc_url="jdbc:mysql://localhost:3306/server";
	private String db_id="root";
	private String db_pw="1111";
	public Statement stmt;
	public ResultSet rs;
	public ResultSetMetaData rsm;
	public String sql;
	public UserPreference up;
	
	private UserInformation userInformation;
	private MainFrame mainFrame;
	
	public DBProcess(MainFrame mf){
		setConnect();
		this.mainFrame = mf;
		
	}
	
	
	public void setConnect(){
		try {
			Class.forName("com.mysql.jdbc.Driver");
		} catch (ClassNotFoundException e1) {
			System.out.println("err "+e1.getMessage());
			e1.printStackTrace();
		}
		
		try {
			con = DriverManager.getConnection(jdbc_url,db_id,db_pw);
			System.out.println("DBProcess-connect");
		} catch (SQLException e) {
			System.out.println("fail to connect");
		}
		try {
			stmt = con.createStatement();
			System.out.println("stmt");
		} catch (SQLException e) {
			
			e.printStackTrace();
		}
	}
	public void closeConnect(){
		try {
			if(rs != null) rs.close();
			if(stmt != null) stmt.close();
			if(con != null) con.close();
			System.out.println("DBProcess close");
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void dupCheck(UserInfo user){
		String str=null;
		sql = "select count(id) from user_info where id='"+user.getId()+"'";
		try {
			rs = stmt.executeQuery(sql);
			
			while(rs.next()){
				str = rs.getString(1);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
		}
		if(str.equals("0")){
			user.setFlag(true);
			
		}
		else{
			user.setFlag(false);
			
		}
		mainFrame.isCorrectInfo(user);
		
	}
	
	public void insertUser(UserInformation uf){
		this.userInformation = uf;
		sql = "insert into user_info values('"+uf.getUserId()+"','"+uf.getUserPWD()+
		"','"+uf.getUserIp()+"','"+uf.getUserName()+"')";
		
		try {
			stmt.executeUpdate(sql);
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void isExist(UserInformation uf){
		this.userInformation = uf;
		String savedPw = null,savedId = null;
		
		sql = "select id,pw from user_info where id='"+uf.getUserId()+"'";
		
		try {
			rs = stmt.executeQuery(sql);
			while(rs.next()){
				savedId=rs.getString(1);
				savedPw=rs.getString(2);
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		if(!(uf.getUserId().equals(savedId))){
			uf.setFlag(false);
		}
		else{
			if(!(uf.getUserPWD().equals(savedPw))){
				uf.setFlag(false);
			}
			else{
				uf.setFlag(true);
			}
		}
		mainFrame.sendUserInformation(userInformation);
	}
	
	@SuppressWarnings("unchecked")
	public Vector<Product>[] getLook(String str){
		Vector<Product>[] va = new Vector[3];
		
		Vector<Product> accSet = new Vector<Product>();
		Vector<Product> topSet = new Vector<Product>();
		Vector<Product> bottomSet = new Vector<Product>();
		
		va[0] = accSet;
		va[1] = topSet;
		va[2] = bottomSet;
		
	
		sql = "select style,section,utility,price,brand,splendor,colorful," +
				"season,weather,img,site,feature,num from product_values where style='"+
		str+"' and section='acc'";
		try {
			rs = stmt.executeQuery(sql);
			rsm = (ResultSetMetaData) rs.getMetaData();
			
		
			while(rs.next()){
				Product p = new Product();
				p.setStyle(rs.getString(1));
				p.setSection(rs.getString(2));
				p.setUtility(rs.getInt(3));
				p.setPrice(rs.getInt(4));
				p.setBrand(rs.getInt(5));
				p.setSplendor(rs.getInt(6));
				p.setColorful(rs.getInt(7));
				p.setSeason(rs.getString(8));
				p.setWeather(rs.getString(9));
				p.setImagePath(rs.getString(10));
				p.setSite(rs.getString(11));
				p.setFeature(rs.getString(12));
				p.setProductNum(Integer.parseInt(rs.getString(13)));
				accSet.add(p);
				
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			System.out.println(e.getMessage());
		}
		
		sql = "select style,section,utility,price,brand,splendor,colorful," +
		"season,weather,img,site,feature,num from product_values where style='"+
		str+"' and section='top'";
		
		try {
			rs = stmt.executeQuery(sql);
			
			while(rs.next()){
				Product p = new Product();
				p.setStyle(rs.getString(1));
				p.setSection(rs.getString(2));
				p.setUtility(rs.getInt(3));
				p.setPrice(rs.getInt(4));
				p.setBrand(rs.getInt(5));
				p.setSplendor(rs.getInt(6));
				p.setColorful(rs.getInt(7));
				p.setSeason(rs.getString(8));
				p.setWeather(rs.getString(9));
				p.setImagePath(rs.getString(10));
				p.setSite(rs.getString(11));
				p.setFeature(rs.getString(12));
				p.setProductNum(Integer.parseInt(rs.getString(13)));
				topSet.add(p);
			}
			
		} catch (SQLException e) {
			System.out.println(e.getMessage());
		}
		sql = "select style,section,utility,price,brand,splendor,colorful," +
		"season,weather,img,site,feature,num from product_values where style='"+
		str+"' and section='bottom'";
		
		try {
			rs = stmt.executeQuery(sql);
			
			while(rs.next()){
				Product p = new Product();
				p.setStyle(rs.getString(1));
				p.setSection(rs.getString(2));
				p.setUtility(rs.getInt(3));
				p.setPrice(rs.getInt(4));
				p.setBrand(rs.getInt(5));
				p.setSplendor(rs.getInt(6));
				p.setColorful(rs.getInt(7));
				p.setSeason(rs.getString(8));
				p.setWeather(rs.getString(9));
				p.setImagePath(rs.getString(10));
				p.setSite(rs.getString(11));
				p.setFeature(rs.getString(12));
				p.setProductNum(Integer.parseInt(rs.getString(13)));
				bottomSet.add(p);
			}
		} catch (SQLException e) {
			System.out.println(e.getMessage());
		}
		
		/*for(int i=0;i<va.length;i++){
			for(int j=0;j<va[i].size();j++){
				System.out.println(va[i].elementAt(j).getSection()+ ":");
				System.out.println(va[i].elementAt(j).getProductNum());
				
			}
		}*/
		
		
		return va;
	}
	
	public Vector<Product> recentRecommend(){
		Vector<Product> rcntProduct = new Vector<Product>();
		int count = 0;
		sql = "select max(num) from product_values";
		try {
			rs = stmt.executeQuery(sql);
			while(rs.next()){
				count = rs.getInt(1);
			}

		} catch (SQLException e) {
			System.out.println("err1"+e.getMessage());
		}
		System.out.println("count : "+count);
		sql = "select img,site,num,feature from product_values where num between "+(count-9)+
		" and "+count;
		
		try {
			rs = stmt.executeQuery(sql);
			
			while(rs.next()){
				Product rp = new Product();
				rp.setImagePath(rs.getString(1));
				rp.setSite(rs.getString(2));
				rp.setProductNum(rs.getInt(3));
				rp.setFeature(rs.getString(4));
				rcntProduct.add(rp);
			}
		} catch (SQLException e) {
			System.out.println("err2"+e.getMessage());
		}
		System.out.println("rcntProduct :"+rcntProduct.size());
		return rcntProduct;
	}
	
	public Vector<Product> popularRecommend(){
		Vector<Product> popProduct = new Vector<Product>();
		
		sql = "select num,img,site,feature from product_values order by popular desc limit 10";
		
		try {
			rs = stmt.executeQuery(sql);
			
			while(rs.next()){
				Product pp = new Product();
				pp.setProductNum(rs.getInt(1));
				pp.setImagePath(rs.getString(2));
				pp.setSite(rs.getString(3));
				pp.setFeature(rs.getString(4));
				popProduct.add(pp);
			}
		} catch (SQLException e) {
			e.getMessage();
		}
		return popProduct;
	}
	public void bookMark(Recommendation d){
		
		System.out.println(" :" + d.getProductNum()+ ":"+ d.getUserId());
		  String section=null;
		  sql = "select section from product_values where num="+d.getProductNum();
		  try {
		   rs = stmt.executeQuery(sql);
		   
		   while(rs.next()){
		    section = rs.getString(1);
		   }
		  } catch (SQLException e) {
		   e.getMessage();
		  }
		  sql = "insert into user_bookmark values('"+d.getUserId()+
		  "',"+d.getProductNum()+",'"+section+"')";
		  
		  try {
		   stmt.executeUpdate(sql);
		  } catch (SQLException e) {
		   e.getMessage();
		  }
		  
		  int pop=0;
		  sql = "select popular from product_vaues where num="+d.getProductNum();
		  try {
			rs = stmt.executeQuery(sql);
			while(rs.next()){
				pop = rs.getInt(1);
			}
			
		} catch (SQLException e) {
			e.getMessage();
		}
		System.out.println("pop "+pop);
		pop += 1;
		System.out.println("pop "+pop);
		sql = "update product_values set popular="+pop+" where num="+d.getProductNum();
		
		try {
			stmt.executeUpdate(sql);
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

}
