package Main;

import java.awt.Color;

import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.MemoryImageSource;
import java.util.ArrayList;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;

import UI.DBTab;

import Communication.ClientHandler;
import DB.DBProcess;
import Element.ElementImage;
import Element.Product;
import Element.ProductSt;
import Element.Recommendation;
import Element.UserInfo;
import Element.UserInformation;
import Element.UserPreference;


public class MainFrame extends JFrame implements ActionListener{
	
	private static final long serialVersionUID = 1L;
	private Thread server;
	private JButton bt_start;
	private Vector<ClientHandler> clientVector;
	private DBTab dbTab;
	public DBProcess dbProcess;
	
	public MainFrame(){
		super("server");
		this.sub();
	}
	public void sub(){
		this.setLayout(null);
		this.setBounds(new Rectangle(100,100,1024,630));
		
		this.bt_start = new JButton("start server");
		
		dbProcess = new DBProcess(this);
		this.dbTab = new DBTab();
		dbTab.valueTab.getDbProcess(this.dbProcess);
		dbTab.userTab.getDbProcess(this.dbProcess);
		dbTab.bmarkTab.getDbProcess(this.dbProcess);
		dbTab.setBounds(new Rectangle(0,0,1024,570));
		bt_start.setBounds(new Rectangle(0,570,1024,25));
		this.add(this.bt_start);
		this.add(dbTab);
		
		dbTab.valueTab.setMf(this);
		
		
		this.bt_start.addActionListener(this);
		this.bt_start.setBackground(Color.white);
		
		this.clientVector = new Vector<ClientHandler>();
	
		
		this.setVisible(true);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		
		
	}
	public Vector<ClientHandler> getClientHandlers(){
		return this.clientVector;
	}
	public void addClient(ClientHandler client){
		this.clientVector.add(client);
	}
	
	public void removeclient(ClientHandler client){
		this.clientVector.remove(client);
	}
	public void drawImage(ElementImage element){
		element.image = createImage(new MemoryImageSource(element.imageWidth, 
				element.imageHeight, element.imagePixel, 0, element.imageWidth));
		Graphics g = this.getGraphics();
		g.drawImage(element.image, 0, 0, 100, 100, null);
	}
	
	public void recommend(Recommendation d){
		this.dbProcess.bookMark(d);
	}
	
	public ProductSt makeProductSet(){
		
		Product Top = new Product();
		Top.setImagePath("images/image1.jpg");
		
		Product Bottom = new Product();
		Bottom.setImagePath("images/image2.jpg");
		
		Product Accessary = new Product();
		Accessary.setImagePath("images/image3.jpg");
		
		ProductSt ps = new ProductSt();
		ps.setTop(Top);
		ps.setBottom(Bottom);
		ps.setAccessary(Accessary);
		
		
		return ps;
	}
	
	
	
	public ArrayList<ProductSt> getProductList(UserPreference UPf){
	
		ArrayList<ProductSt> list = new ArrayList<ProductSt>();
		Vector<Product> [] vectorArr = this.dbProcess.getLook(UPf.getStyle());
		
		Vector<Product> accSet = vectorArr[0];
		Vector<Product> topSet = vectorArr[1];
		Vector<Product> bottomSet = vectorArr[2];
		
	
		for(int i=0;i<accSet.size();i++){
			accSet.elementAt(i).accUpf(UPf);
			System.out.println("b :"+accSet.elementAt(i).result);
			if(UPf.getSeason()!= null){
				if(UPf.getSeason().equals(accSet.elementAt(i).getSeason())){
					accSet.elementAt(i).result -=5; 
				}
				//System.out.println("aftereeee :"+accSet.elementAt(i).result);
			}else{
				//System.out.println("afteraaaa :"+accSet.elementAt(i).result);
			}

			topSet.elementAt(i).accUpf(UPf);
			if(UPf.getSeason()!= null){
				if(UPf.getSeason().equals(topSet.elementAt(i).getSeason())){
					topSet.elementAt(i).result -=5; 
				}
			}
			bottomSet.elementAt(i).accUpf(UPf);
			if(UPf.getSeason()!= null){
				if(UPf.getSeason().equals(bottomSet.elementAt(i).getSeason())){
					bottomSet.elementAt(i).result -=5; 
				}
			}
		}
		
		
	
		
		for(int i=0;i<accSet.size();i++){
			int count =0;
			for(int j=0;j<accSet.size();j++){
				if(accSet.elementAt(i).result>accSet.elementAt(j).result){
					count++;
				}
			}
			accSet.elementAt(i).index = count;
		}
		
		for(int i=0;i<topSet.size();i++){
			int count =0;
			for(int j=0;j<topSet.size();j++){
				if(topSet.elementAt(i).result>topSet.elementAt(j).result){
					count++;
				}
			}
			topSet.elementAt(i).index = count;
		}
		
		for(int i=0;i<bottomSet.size();i++){
			int count =0;
			for(int j=0;j<bottomSet.size();j++){
				if(bottomSet.elementAt(i).result>bottomSet.elementAt(j).result){
					count++;
				}
			}
			bottomSet.elementAt(i).index = count;
		}
		
		
		
		Product[] pArr = new Product[accSet.size()];
		Product[] pArr1 = new Product[accSet.size()];
		Product[] pArr2 = new Product[accSet.size()];
		
		for(int i=0;i<accSet.size();i++){
			for(int j=0;j<accSet.size();j++){
				if(i == accSet.elementAt(j).index){
					if(pArr[i]!= null){
						for(int k = i;k<accSet.size();k++){
							if(pArr[k]== null){
								pArr[k] = accSet.elementAt(j);
								break;
							}
						}
					}else{
						pArr[i] = accSet.elementAt(j);
					}
				}
			}
		}
		
		for(int i=0;i<topSet.size();i++){
			for(int j=0;j<topSet.size();j++){
				if(i == topSet.elementAt(j).index){
					if(pArr1[i]!= null){
						for(int k = i;k<topSet.size();k++){
							if(pArr1[k]== null){
								pArr1[k] = topSet.elementAt(j);
								break;
							}
						}
					}else{
						pArr1[i] = topSet.elementAt(j);
					}
				}
			}
		}
		
		for(int i=0;i<bottomSet.size();i++){
			for(int j=0;j<bottomSet.size();j++){
				if(i == bottomSet.elementAt(j).index){
					if(pArr2[i]!= null){
						for(int k = i;k<bottomSet.size();k++){
							if(pArr2[k]== null){
								pArr2[k] = bottomSet.elementAt(j);
								break;
							}
						}
					}else{
						pArr2[i] = bottomSet.elementAt(j);
					}
				}
			}
		}
		
		/*for(int i=0;i<10;i++){
			list.add(this.makeProductSet());
		}*/
		for(int i=0;i<accSet.size();i++){
			ProductSt ps= new ProductSt();
			ps.setAccessary(pArr[i]);
			ps.setTop(pArr1[i]);
			ps.setBottom(pArr2[i]);
			list.add(ps);
		}
		return list;
	}
	
	public void sendUserInformation(UserInformation user){
		UserInformation userInformation = user;
		for(int i=0;i<this.clientVector.size();i++){
			if(userInformation.getUserIp().equals(this.clientVector.elementAt(i).getRemoteSocketAddress())){
				this.clientVector.elementAt(i).sendUserInformation(userInformation);
			}
		}
	}
	
	public void isCorrectInfo(UserInfo user){

		for(int i=0;i<this.clientVector.size();i++){
			if(user.getIp().equals(clientVector.elementAt(i).getRemoteSocketAddress())){
				clientVector.elementAt(i).sendUser(user);
			}
		}
	
	}
	
	
	public void insertUser(UserInformation uf) {
		dbProcess.insertUser(uf);
		
	}
	
	public void isExist(UserInformation uf){
		dbProcess.isExist(uf);
	}
	
	public void actionPerformed(ActionEvent e) {
		Object o = e.getSource();
		if(o == this.bt_start ){
			if(this.server == null){
				this.server = new server(this);
				server.start();
			}
		}
	}
	
	public static void main(String args[]){
		new MainFrame();
	}
	
}
